require "collisions"

local gold = {}
gold.__index = gold

function newGold(object)
	local n = object
	n.width = 8
	n.height = 8
	n.img = lutro.graphics.newImage("assets/gold.png")

	return setmetatable(n, gold)
end

function gold:update(dt)
end

function gold:draw()
	lutro.graphics.draw(self.img, self.x, self.y)
end

function gold:on_collide(e1, e2, dx, dy)
	if e2.type == "ground" then
		if math.abs(dy) < math.abs(dx) and dy ~= 0 then
			self.yspeed = 0
			self.y = self.y + dy
			if dy < -1 and not self.using_lader then
				lutro.audio.play(sfx_step)
			end
		end

		if math.abs(dx) < math.abs(dy) and dx ~= 0 then
			self.xspeed = 0
			self.x = self.x + dx
		end
	elseif e2.type == "character" then
		lutro.audio.play(sfx_gold)
		for i=1, #entities do
			if entities[i] == self then
				table.remove(entities, i)
			end
		end
	end
end
